Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4497)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4498)
@@ -834,49 +825,48 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Initialize virtual measurements: read coordiante arrays and measured
-!> variables, set indicies indicating the measurement points, read further
-!> attributes, etc..
-!------------------------------------------------------------------------------!
+!> Initialize virtual measurements: read coordiante arrays and measured variables, set indicies
+!> indicating the measurement points, read further attributes, etc..
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE vm_init
 
-    CHARACTER(LEN=5)                  ::  dum                          !< dummy string indicating station id
-    CHARACTER(LEN=100), DIMENSION(50) ::  measured_variables_file = '' !< array with all measured variables read from NetCDF
-    CHARACTER(LEN=100), DIMENSION(50) ::  measured_variables      = '' !< dummy array with all measured variables that are allowed
-
-    INTEGER(iwp) ::  dim_ntime !< dimension size of time coordinate
-    INTEGER(iwp) ::  i         !< grid index of virtual observation point in x-direction
-    INTEGER(iwp) ::  is        !< grid index of real observation point of the respective station in x-direction
-    INTEGER(iwp) ::  j         !< grid index of observation point in x-direction
-    INTEGER(iwp) ::  js        !< grid index of real observation point of the respective station in y-direction
-    INTEGER(iwp) ::  k         !< grid index of observation point in x-direction
-    INTEGER(iwp) ::  kl        !< lower vertical index of surrounding grid points of an observation coordinate
-    INTEGER(iwp) ::  ks        !< grid index of real observation point of the respective station in z-direction
-    INTEGER(iwp) ::  ksurf     !< topography top index
-    INTEGER(iwp) ::  ku        !< upper vertical index of surrounding grid points of an observation coordinate
-    INTEGER(iwp) ::  l         !< running index over all stations
-    INTEGER(iwp) ::  len_char  !< character length of single measured variables without Null character
-    INTEGER(iwp) ::  ll        !< running index over all measured variables in file
-    INTEGER(iwp) ::  m         !< running index for surface elements
-    INTEGER(iwp) ::  n         !< running index over trajectory coordinates
-    INTEGER(iwp) ::  nofill    !< dummy for nofill return value (not used)
-    INTEGER(iwp) ::  ns        !< counter variable for number of observation points on subdomain
-    INTEGER(iwp) ::  off       !< number of surrounding grid points to be sampled
-    INTEGER(iwp) ::  t         !< running index over number of trajectories
-
-    INTEGER(KIND=1)                             ::  soil_dum !< dummy variable to input a soil flag
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE     ::  ns_all !< dummy array used to sum-up the number of observation coordinates
+    CHARACTER(LEN=5)                  ::  dum                           !< dummy string indicating station id
+    CHARACTER(LEN=100), DIMENSION(50) ::  measured_variables_file = ''  !< array with all measured variables read from NetCDF
+    CHARACTER(LEN=100), DIMENSION(50) ::  measured_variables      = ''  !< dummy array with all measured variables that are allowed
+
+    INTEGER(iwp) ::  dim_ntime  !< dimension size of time coordinate
+    INTEGER(iwp) ::  i          !< grid index of virtual observation point in x-direction
+    INTEGER(iwp) ::  is         !< grid index of real observation point of the respective station in x-direction
+    INTEGER(iwp) ::  j          !< grid index of observation point in x-direction
+    INTEGER(iwp) ::  js         !< grid index of real observation point of the respective station in y-direction
+    INTEGER(iwp) ::  k          !< grid index of observation point in x-direction
+    INTEGER(iwp) ::  kl         !< lower vertical index of surrounding grid points of an observation coordinate
+    INTEGER(iwp) ::  ks         !< grid index of real observation point of the respective station in z-direction
+    INTEGER(iwp) ::  ksurf      !< topography top index
+    INTEGER(iwp) ::  ku         !< upper vertical index of surrounding grid points of an observation coordinate
+    INTEGER(iwp) ::  l          !< running index over all stations
+    INTEGER(iwp) ::  len_char   !< character length of single measured variables without Null character
+    INTEGER(iwp) ::  ll         !< running index over all measured variables in file
+    INTEGER(iwp) ::  m          !< running index for surface elements
+    INTEGER(iwp) ::  n          !< running index over trajectory coordinates
+    INTEGER(iwp) ::  nofill     !< dummy for nofill return value (not used)
+    INTEGER(iwp) ::  ns         !< counter variable for number of observation points on subdomain
+    INTEGER(iwp) ::  off        !< number of surrounding grid points to be sampled
+    INTEGER(iwp) ::  t          !< running index over number of trajectories
+
+    INTEGER(KIND=1)                             ::  soil_dum  !< dummy variable to input a soil flag
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE     ::  ns_all  !< dummy array used to sum-up the number of observation coordinates
 
 #if defined( __parallel )
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  ns_atmos !< number of observation points for each station on each mpi rank
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  ns_soil  !< number of observation points for each station on each mpi rank
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  ns_atmos  !< number of observation points for each station on each mpi rank
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  ns_soil   !< number of observation points for each station on each mpi rank
 #endif
 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  meas_flag !< mask array indicating measurement positions
-
-    LOGICAL  ::  on_pe        !< flag indicating that the respective measurement coordinate is on subdomain
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  meas_flag  !< mask array indicating measurement positions
+
+    LOGICAL  ::  on_pe  !< flag indicating that the respective measurement coordinate is on subdomain
 
     REAL(wp) ::  fill_eutm !< _FillValue for coordinate array E_UTM
@@ -884,10 +874,10 @@
     REAL(wp) ::  fill_zar  !< _FillValue for height coordinate
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  e_utm     !< easting UTM coordinate, temporary variable
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  n_utm     !< northing UTM coordinate, temporary variable
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  e_utm_tmp !< EUTM coordinate before rotation
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  n_utm_tmp !< NUTM coordinate before rotation
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  station_h !< station height above reference
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zar       !< observation height above reference
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  e_utm      !< easting UTM coordinate, temporary variable
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  e_utm_tmp  !< EUTM coordinate before rotation
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  n_utm      !< northing UTM coordinate, temporary variable
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  n_utm_tmp  !< NUTM coordinate before rotation
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  station_h  !< station height above reference
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zar        !< observation height above reference
 #if defined( __netcdf )
 !
@@ -896,18 +886,13 @@
 !
 !-- Obtain number of sites.
-    CALL get_attribute( pids_id,                                               &
-                        char_numstations,                                      &
-                        vmea_general%nvm,                                      &
-                        global_attribute )
-!
-!-- Allocate data structure which encompass all required information, such as
-!-- grid points indicies, absolute UTM coordinates, the measured quantities,
-!-- etc. .
+    CALL get_attribute( pids_id, char_numstations, vmea_general%nvm, global_attribute )
+!
+!-- Allocate data structure which encompasses all required information, such as  grid points indicies,
+!-- absolute UTM coordinates, the measured quantities, etc. .
     ALLOCATE( vmea(1:vmea_general%nvm) )
 !
-!-- Allocate flag array. This dummy array is used to identify grid points
-!-- where virtual measurements should be taken. Please note, in order to
-!-- include also the surrounding grid points of the original coordinate
-!-- ghost points are required.
+!-- Allocate flag array. This dummy array is used to identify grid points where virtual measurements
+!-- should be taken. Please note, in order to include also the surrounding grid points of the
+!-- original coordinate, ghost points are required.
     ALLOCATE( meas_flag(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
     meas_flag = 0
@@ -916,6 +901,5 @@
     DO  l = 1, vmea_general%nvm
 !
-!--    Determine suffix which contains the ID, ordered according to the number
-!--    of measurements.
+!--    Determine suffix which contains the ID, ordered according to the number of measurements.
        IF( l < 10 )  THEN
           WRITE( dum, '(I1)')  l
@@ -931,25 +915,13 @@
 !
 !--    Read the origin site coordinates (UTM).
-       CALL get_attribute( pids_id,                                            &
-                           char_origx // TRIM( dum ),                          &
-                           vmea(l)%origin_x_obs,                               &
-                           global_attribute )
-       CALL get_attribute( pids_id,                                            &
-                           char_origy // TRIM( dum ),                          &
-                           vmea(l)%origin_y_obs,                               &
-                           global_attribute )
+       CALL get_attribute( pids_id, char_origx // TRIM( dum ), vmea(l)%origin_x_obs, global_attribute )
+       CALL get_attribute( pids_id, char_origy // TRIM( dum ), vmea(l)%origin_y_obs, global_attribute )
 !
 !--    Read site name.
-       CALL get_attribute( pids_id,                                            &
-                           char_site // TRIM( dum ),                           &
-                           vmea(l)%site,                                       &
-                           global_attribute )
-!
-!--    Read a flag which indicates that also soil quantities are take at the
-!--    respective site (is part of the virtual measurement driver).
-       CALL get_attribute( pids_id,                                            &
-                           char_soil // TRIM( dum ),                           &
-                           soil_dum,                                           &
-                           global_attribute )
+       CALL get_attribute( pids_id, char_site // TRIM( dum ), vmea(l)%site, global_attribute )
+!
+!--    Read a flag which indicates that also soil quantities are take at the respective site
+!--    (is part of the virtual measurement driver).
+       CALL get_attribute( pids_id, char_soil // TRIM( dum ), soil_dum, global_attribute )
 !
 !--    Set flag indicating soil-sampling.
@@ -957,8 +929,5 @@
 !
 !--    Read type of the measurement (trajectory, profile, timeseries).
-       CALL get_attribute( pids_id,                                            &
-                           char_feature // TRIM( dum ),                        &
-                           vmea(l)%feature_type,                               &
-                           global_attribute )
+       CALL get_attribute( pids_id, char_feature // TRIM( dum ), vmea(l)%feature_type, global_attribute )
 !
 !---   Set logicals depending on the type of the measurement
@@ -972,7 +941,5 @@
 !--    Give error message in case the type matches non of the pre-defined types.
        ELSE
-          message_string = 'Attribue featureType = ' //                        &
-                           TRIM( vmea(l)%feature_type ) //                     &
-                           ' is not allowed.'
+          message_string = 'Attribue featureType = ' // TRIM( vmea(l)%feature_type ) // ' is not allowed.'
           CALL message( 'vm_init', 'PA0535', 1, 2, 0, 6, 0 )
        ENDIF
@@ -980,28 +947,24 @@
 !--    Read string with all measured variables at this site.
        measured_variables_file = ''
-       CALL get_variable( pids_id,                                             &
-                          char_mv // TRIM( dum ),                              &
-                          measured_variables_file )
+       CALL get_variable( pids_id, char_mv // TRIM( dum ), measured_variables_file )
 !
 !--    Count the number of measured variables.
-!--    Please note, for some NetCDF interal reasons characters end with a NULL,
-!--    i.e. also empty characters contain a NULL. Therefore, check the strings
-!--    for a NULL to get the correct character length in order to compare
-!--    them with the list of allowed variables.
+!--    Please note, for some NetCDF interal reasons, characters end with a NULL, i.e. also empty
+!--    characters contain a NULL. Therefore, check the strings for a NULL to get the correct
+!--    character length in order to compare them with the list of allowed variables.
        vmea(l)%nmeas  = 1
-       DO ll = 1, SIZE( measured_variables_file )
-          IF ( measured_variables_file(ll)(1:1) /= CHAR(0)  .AND.              &
+       DO  ll = 1, SIZE( measured_variables_file )
+          IF ( measured_variables_file(ll)(1:1) /= CHAR(0)  .AND.                                  &
                measured_variables_file(ll)(1:1) /= ' ')  THEN
 !
 !--          Obtain character length of the character
              len_char = 1
-             DO WHILE ( measured_variables_file(ll)(len_char:len_char) /= CHAR(0)&
-                 .AND.  measured_variables_file(ll)(len_char:len_char) /= ' ' )
+             DO  WHILE ( measured_variables_file(ll)(len_char:len_char) /= CHAR(0)  .AND.          &
+                 measured_variables_file(ll)(len_char:len_char) /= ' ' )
                 len_char = len_char + 1
              ENDDO
              len_char = len_char - 1
 
-             measured_variables(vmea(l)%nmeas) =                               &
-                                       measured_variables_file(ll)(1:len_char)
+             measured_variables(vmea(l)%nmeas) = measured_variables_file(ll)(1:len_char)
              vmea(l)%nmeas = vmea(l)%nmeas + 1
 
@@ -1010,57 +973,47 @@
        vmea(l)%nmeas = vmea(l)%nmeas - 1
 !
-!--    Allocate data-type array for the measured variables names and attributes
-!--    at the respective site.
+!--    Allocate data-type array for the measured variables names and attributes at the respective
+!--    site.
        ALLOCATE( vmea(l)%var_atts(1:vmea(l)%nmeas) )
 !
-!--    Store the variable names in a data structures, which assigns further
-!--    attributes to this name. Further, for data output reasons, create a
-!--    string of output variables, which will be written into the attribute
-!--    data_content.
+!--    Store the variable names in a data structure, which assigns further attributes to this name.
+!--    Further, for data output reasons, create a string of output variables, which will be written
+!--    into the attribute data_content.
        DO  ll = 1, vmea(l)%nmeas
           vmea(l)%var_atts(ll)%name = TRIM( measured_variables(ll) )
 
-          vmea(l)%data_content = TRIM( vmea(l)%data_content ) // " " //        &
+          vmea(l)%data_content = TRIM( vmea(l)%data_content ) // " " //                            &
                                  TRIM( vmea(l)%var_atts(ll)%name )
        ENDDO
 !
-!--    Read all the UTM coordinates for the site. Based on the coordinates,
-!--    define the grid-index space on each subdomain where virtual measurements
-!--    should be taken. Note, the entire coordinate array (on the entire model
-!--    domain) won't be stored as this would exceed memory requirements,
-!--    particularly for trajectories.
+!--    Read all the UTM coordinates for the site. Based on the coordinates, define the grid-index
+!--    space on each subdomain where virtual measurements should be taken. Note, the entire
+!--    coordinate array (on the entire model domain) won't be stored as this would exceed memory
+!--    requirements, particularly for trajectories.
        IF ( vmea(l)%nmeas > 0 )  THEN
 !
-!--       For stationary measurements UTM coordinates are just one value and
-!--       its dimension is "station", while for mobile measurements UTM
-!--       coordinates are arrays depending on the number of trajectories and
-!--       time, according to (UC)2 standard. First, inquire dimension length
-!--       of the UTM coordinates.
+!--       For stationary measurements UTM coordinates are just one value and its dimension is
+!--       "station", while for mobile measurements UTM coordinates are arrays depending on the
+!--       number of trajectories and time, according to (UC)2 standard. First, inquire dimension
+!--       length of the UTM coordinates.
           IF ( vmea(l)%trajectory )  THEN
 !
-!--          For non-stationary measurements read the number of trajectories
-!--          and the number of time coordinates.
-             CALL get_dimension_length( pids_id,                               &
-                                        vmea(l)%n_tr_st,                       &
-                                        "traj" // TRIM( dum ) )
-             CALL get_dimension_length( pids_id,                               &
-                                        dim_ntime,                             &
-                                        "ntime" // TRIM( dum ) )
-!
-!--       For stationary measurements the dimension for UTM is station
-!--       and for the time-coordinate it is one.
+!--          For non-stationary measurements read the number of trajectories and the number of time
+!--          coordinates.
+             CALL get_dimension_length( pids_id, vmea(l)%n_tr_st, "traj" // TRIM( dum ) )
+             CALL get_dimension_length( pids_id, dim_ntime, "ntime" // TRIM( dum ) )
+!
+!--       For stationary measurements the dimension for UTM is station and for the time-coordinate
+!--       it is one.
           ELSE
-             CALL get_dimension_length( pids_id,                               &
-                                        vmea(l)%n_tr_st,                       &
-                                        "station" // TRIM( dum ) )
+             CALL get_dimension_length( pids_id, vmea(l)%n_tr_st, "station" // TRIM( dum ) )
              dim_ntime = 1
           ENDIF
 !
-!-        Allocate array which defines individual time/space frame for each
-!--       trajectory or station.
+!-        Allocate array which defines individual time/space frame for each trajectory or station.
           ALLOCATE( vmea(l)%dim_t(1:vmea(l)%n_tr_st) )
 !
-!--       Allocate temporary arrays for UTM and height coordinates. Note,
-!--       on file UTM coordinates might be 1D or 2D variables
+!--       Allocate temporary arrays for UTM and height coordinates. Note, on file UTM coordinates
+!--       might be 1D or 2D variables
           ALLOCATE( e_utm(1:vmea(l)%n_tr_st,1:dim_ntime)       )
           ALLOCATE( n_utm(1:vmea(l)%n_tr_st,1:dim_ntime)       )
@@ -1075,56 +1028,28 @@
           ALLOCATE( n_utm_tmp(1:vmea(l)%n_tr_st,1:dim_ntime) )
 !
-!--       Read UTM and height coordinates coordinates for all trajectories and
-!--       times. Note, in case these obtain any missing values, replace them
-!--       with default _FillValues.
-          CALL inquire_fill_value( pids_id,                                    &
-                                   char_eutm // TRIM( dum ),                   &
-                                   nofill,                                     &
-                                   fill_eutm )
-          CALL inquire_fill_value( pids_id,                                    &
-                                   char_nutm // TRIM( dum ),                   &
-                                   nofill,                                     &
-                                   fill_nutm )
-          CALL inquire_fill_value( pids_id,                                    &
-                                   char_zar // TRIM( dum ),                    &
-                                   nofill,                                     &
-                                   fill_zar )
-!
-!--       Further line is just to avoid compiler warnings. nofill might be used
-!--       in future.
+!--       Read UTM and height coordinates for all trajectories and times. Note, in case
+!--       these obtain any missing values, replace them with default _FillValues.
+          CALL inquire_fill_value( pids_id, char_eutm // TRIM( dum ), nofill, fill_eutm )
+          CALL inquire_fill_value( pids_id, char_nutm // TRIM( dum ), nofill, fill_nutm )
+          CALL inquire_fill_value( pids_id, char_zar // TRIM( dum ), nofill, fill_zar )
+!
+!--       Further line is just to avoid compiler warnings. nofill might be used in future.
           IF ( nofill == 0  .OR.  nofill /= 0 )  CONTINUE
 !
-!--       Read observation coordinates. Please note, for trajectories the
-!--       observation height is stored directly in z, while for timeSeries
-!--       it is stored in z - station_h, according to UC2-standard.
+!--       Read observation coordinates. Please note, for trajectories the observation height is
+!--       stored directly in z, while for timeSeries it is stored in z - station_h, according to
+!--       UC2-standard.
           IF ( vmea(l)%trajectory )  THEN
-             CALL get_variable( pids_id,                                       &
-                                char_eutm // TRIM( dum ),                      &
-                                e_utm,                                         &
-                                0, dim_ntime-1,                                &
-                                0, vmea(l)%n_tr_st-1 )
-             CALL get_variable( pids_id,                                       &
-                                char_nutm // TRIM( dum ),                      &
-                                n_utm,                                         &
-                                0, dim_ntime-1,                                &
-                                0, vmea(l)%n_tr_st-1 )
-             CALL get_variable( pids_id,                                       &
-                                char_zar // TRIM( dum ),                       &
-                                zar,                                           &
-                                0, dim_ntime-1,                                &
-                                0, vmea(l)%n_tr_st-1 )
+             CALL get_variable( pids_id, char_eutm // TRIM( dum ), e_utm, 0, dim_ntime-1, 0,       &
+                                vmea(l)%n_tr_st-1 )
+             CALL get_variable( pids_id, char_nutm // TRIM( dum ), n_utm, 0, dim_ntime-1, 0,       &
+                                vmea(l)%n_tr_st-1 )
+             CALL get_variable( pids_id, char_zar // TRIM( dum ), zar, 0, dim_ntime-1, 0,          &
+                                vmea(l)%n_tr_st-1 )
           ELSE
-             CALL get_variable( pids_id,                                       &
-                                char_eutm // TRIM( dum ),                      &
-                                e_utm(:,1) )
-             CALL get_variable( pids_id,                                       &
-                                char_nutm // TRIM( dum ),                      &
-                                n_utm(:,1) )
-             CALL get_variable( pids_id,                                       &
-                                char_station_h // TRIM( dum ),                 &
-                                station_h(:,1) )
-             CALL get_variable( pids_id,                                       &
-                                char_zar // TRIM( dum ),                       &
-                                zar(:,1) )
+             CALL get_variable( pids_id, char_eutm // TRIM( dum ), e_utm(:,1) )
+             CALL get_variable( pids_id, char_nutm // TRIM( dum ), n_utm(:,1) )
+             CALL get_variable( pids_id, char_station_h // TRIM( dum ), station_h(:,1) )
+             CALL get_variable( pids_id, char_zar // TRIM( dum ), zar(:,1) )
           ENDIF
 
@@ -1136,45 +1061,39 @@
           zar  = zar - station_h
 !
-!--       Based on UTM coordinates, check if the measurement station or parts
-!--       of the trajectory are on subdomain. This case, setup grid index space
-!--       sample these quantities.
+!--       Based on UTM coordinates, check if the measurement station or parts of the trajectory are
+!--       on subdomain. This case, setup grid index space sample these quantities.
           meas_flag = 0
           DO  t = 1, vmea(l)%n_tr_st
 !
-!--          First, compute relative x- and y-coordinates with respect to the
-!--          lower-left origin of the model domain, which is the difference
-!--          between UTM coordinates. Note, if the origin is not correct, the
-!--          virtual sites will be misplaced. Further, in case of an rotated
-!--          model domain, the UTM coordinates must be also rotated.
+!--          First, compute relative x- and y-coordinates with respect to the lower-left origin of
+!--          the model domain, which is the difference between UTM coordinates. Note, if the origin
+!--          is not correct, the virtual sites will be misplaced. Further, in case of an rotated
+!--          model domain, the UTM coordinates must also be rotated.
              e_utm_tmp(t,1:dim_ntime) = e_utm(t,1:dim_ntime) - init_model%origin_x
              n_utm_tmp(t,1:dim_ntime) = n_utm(t,1:dim_ntime) - init_model%origin_y
-             e_utm(t,1:dim_ntime) = COS( init_model%rotation_angle * pi / 180.0_wp ) &
-                                    * e_utm_tmp(t,1:dim_ntime)                       &
-                                  - SIN( init_model%rotation_angle * pi / 180.0_wp ) &
+             e_utm(t,1:dim_ntime) = COS( init_model%rotation_angle * pi / 180.0_wp )               &
+                                    * e_utm_tmp(t,1:dim_ntime)                                     &
+                                  - SIN( init_model%rotation_angle * pi / 180.0_wp )               &
                                     * n_utm_tmp(t,1:dim_ntime)
-             n_utm(t,1:dim_ntime) = SIN( init_model%rotation_angle * pi / 180.0_wp ) &
-                                    * e_utm_tmp(t,1:dim_ntime)                       &
-                                  + COS( init_model%rotation_angle * pi / 180.0_wp ) &
+             n_utm(t,1:dim_ntime) = SIN( init_model%rotation_angle * pi / 180.0_wp )               &
+                                    * e_utm_tmp(t,1:dim_ntime)                                     &
+                                  + COS( init_model%rotation_angle * pi / 180.0_wp )               &
                                     * n_utm_tmp(t,1:dim_ntime)
 !
-!--          Determine the individual time coordinate length for each station and
-!--          trajectory. This is required as several stations and trajectories
-!--          are merged into one file but they do not have the same number of
-!--          points in time, hence, missing values may occur and cannot be
-!--          processed further. This is actually a work-around for the specific
-!--          (UC)2 dataset, but it won't harm anyway.
+!--          Determine the individual time coordinate length for each station and trajectory. This
+!--          is required as several stations and trajectories are merged into one file but they do
+!--          not have the same number of points in time, hence, missing values may occur and cannot
+!--          be processed further. This is actually a work-around for the specific (UC)2 dataset,
+!--          but it won't harm anyway.
              vmea(l)%dim_t(t) = 0
              DO  n = 1, dim_ntime
-                IF ( e_utm(t,n) /= fill_eutm  .AND.                            &
-                     n_utm(t,n) /= fill_nutm  .AND.                            &
+                IF ( e_utm(t,n) /= fill_eutm  .AND.  n_utm(t,n) /= fill_nutm  .AND.                &
                      zar(t,n)   /= fill_zar )  vmea(l)%dim_t(t) = n
              ENDDO
 !
-!--          Compute grid indices relative to origin and check if these are
-!--          on the subdomain. Note, virtual measurements will be taken also
-!--          at grid points surrounding the station, hence, check also for
-!--          these grid points.
-!--          The number of surrounding grid points is set according to the
-!--          featureType.
+!--          Compute grid indices relative to origin and check if these are on the subdomain. Note,
+!--          virtual measurements will be taken also at grid points surrounding the station, hence,
+!--          check also for these grid points. The number of surrounding grid points is set
+!--          according to the featureType.
              IF ( vmea(l)%timseries_profile )  THEN
                 off = off_pr
@@ -1186,22 +1105,20 @@
 
              DO  n = 1, vmea(l)%dim_t(t)
-                is = INT( ( e_utm(t,n) + 0.5_wp * dx ) * ddx, KIND = iwp )
-                js = INT( ( n_utm(t,n) + 0.5_wp * dy ) * ddy, KIND = iwp )
+                 is = INT( ( e_utm(t,n) + 0.5_wp * dx ) * ddx, KIND = iwp )
+                 js = INT( ( n_utm(t,n) + 0.5_wp * dy ) * ddy, KIND = iwp )
 !
 !--             Is the observation point on subdomain?
-                on_pe = ( is >= nxl  .AND.  is <= nxr  .AND.                   &
-                          js >= nys  .AND.  js <= nyn )
-!
-!--             Check if observation coordinate is on subdomain
+                on_pe = ( is >= nxl  .AND.  is <= nxr  .AND.  js >= nys  .AND.  js <= nyn )
+!
+!--             Check if observation coordinate is on subdomain.
                 IF ( on_pe )  THEN
 !
-!--                Determine vertical index which correspond to the observation
-!--                height.
+!--                Determine vertical index which corresponds to the observation height.
                    ksurf = topo_top_ind(js,is,0)
                    ks = MINLOC( ABS( zu - zw(ksurf) - zar(t,n) ), DIM = 1 ) - 1
 !
-!--                Set mask array at the observation coordinates. Also, flag the
-!--                surrounding coordinate points, but first check whether the
-!--                surrounding coordinate points are on the subdomain.
+!--                Set mask array at the observation coordinates. Also, flag the surrounding
+!--                coordinate points, but first check whether the surrounding coordinate points are
+!--                on the subdomain.
                    kl = MERGE( ks-off, ksurf, ks-off >= nzb  .AND. ks-off >= ksurf )
                    ku = MERGE( ks+off, nzt,   ks+off < nzt+1 )
